unit Unit1;

{ DavData Software
  HBot simulator
  august 2023      }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    timelabel: TLabel;
    Label1: TLabel;
    resetBtn: TSpeedButton;
    eraseBtn: TSpeedButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    posXlabel: TStaticText;
    posYlabel: TStaticText;
    Label10: TLabel;
    slowBtn: TSpeedButton;
    normalBtn: TSpeedButton;
    fastBtn: TSpeedButton;
    stepBtn: TCheckBox;
    Label11: TLabel;
    procbox: TPaintBox;
    penmoveBox: TPaintBox;
    demoBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    demoBtn2: TBitBtn;
    demoBtn3: TBitBtn;
    Label12: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure MLboxpaint(sender: Tobject);
    procedure MLboxEnter(sender: Tobject);
    procedure MLboxLeave(sender: TObject);
    procedure MLBoxMouseDown(sender: TObject;  Button: TMouseButton;
                             Shift: TShiftState; X, Y: Integer);
    procedure MLboxMouseUp(sender: TObject; Button: TMouseButton;
                           Shift: TShiftState; X, Y: Integer);
    procedure slowBtnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure resetBtnClick(Sender: TObject);
    procedure procboxPaint(Sender: TObject);
    procedure penmoveBoxPaint(Sender: TObject);
    procedure penmoveBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure penmoveBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure penmoveBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure eraseBtnClick(Sender: TObject);
    procedure demoBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

 procedure procmove(dir : byte);
 procedure setpen(down : boolean);
 procedure GetPenPos(var x,y : smallInt);

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses timer_unit,unit2,demo_unit;

const BGcolorA = $e0e0e0;
      wheelcenter : array[1..4] of TPoint = ((x:40;y:40),(x:860;y:40),
                                             (x:40;y:900),(x:860;y:900));
      wheelcenterC : array[1..4] of Tpoint = ((x:68;y:50),(x:832;y:50),
                                              (x:68;y:119),(x:832;y:119));
      CYbias = 400;     //..
      DXbias = 410;     //relative to posX
      DYbias = 420;     //..          posY
      EXbias = 130;     //relative to mapA
      EYbias = 140;     //..
      beltcolor = $404040;
      leftColumnRect  : Trect = (left:20;top:20;right:62;bottom:925);
      rightColumnRect : Trect = (left:840;top:20;right:882;bottom:925);
      markercount = 22;
      beltmarkers : array[1..markercount] of word =
                   (200,206,600,606,1080,1086,1480,1486,2000,2006,
                    2562,2568,3124,3130,3644,3650,4044,4050,4524,4530,
                    4924,4930);
      Vtimeout : array[1..3] of dword = (30000,10000,2000);//slow,normal,fast

var mapA : TBitmap;
    mapC : Tbitmap;
    mapD : Tbitmap;
    mapX : Tbitmap;
    posX : smallInt;
    posY : smallInt;
    MLbox : TDav7ELbox;
    MRbox : TDav7ELbox;
    MLRbox1 : Tdav7ELbox;
    MLRbox2 : TDav7ELbox;
    penmovemap1 : Tbitmap;
    penmovemap2 : Tbitmap;
    pencontrolmap : Tbitmap;
    moveFlag : boolean;
    speedcode : byte = 2;   //normal
    oldpercX : byte;        //previous proc time %
    purpledot : Tbitmap;
    pendownflag : boolean;
    movebusy : boolean;
    xdircode : byte;       //direction code for manual painting

procedure GetPenPos(var x,y : smallint);
begin
 x := posX;
 y := posY;
end;

procedure AtoX;
begin
 mapX.Canvas.Draw(0,0,mapA);
end;

procedure XtoBox;
begin
 form1.PaintBox1.Canvas.draw(0,0,mapX);
end;

procedure reporttime(t : int64);
begin
 form1.timelabel.caption := formatfloat('##0.###',Proctime(t));
end;

procedure showprocUsage(perc : single);
var newpercX : byte;
    r : Trect;
begin
 if perc > 1 then perc := 1;
 newpercX := round(perc * 100);
 if newpercX = oldpercX then exit;
//
 with r do
  begin
   top := 0;
   bottom := 25;
   if newpercX > oldpercX then
    begin
     left := oldpercX;
     right := newpercX;
     form1.procbox.canvas.brush.color := $ff0000;
    end
    else begin
          left := newpercX;
          right := oldpercX;
          form1.procbox.canvas.brush.color := $ffffff;
         end;
  end;//with r
 form1.procbox.Canvas.fillrect(r);
 oldpercX := newpercX;
end;

procedure adjustString(var s: string);
begin
 while pos('.',s) < 3 do insert(' ',s,1);
end;

procedure showposition;
const scode = '0.0##';
var s : string;
begin
 s := formatfloat(scode,posX*0.025);
 adjuststring(s);
 form1.posXlabel.Caption := s;
 s := formatfloat(scode,-posY*0.025);
 adjuststring(s);
 form1.posYlabel.Caption := s;
end;

procedure paintwheel(x,y,m: smallint);
//m = 1 top m= -1 bottom half circle  
begin
 with mapA do with canvas do
  begin
   pen.width := 1;
   pen.color := $000000;
   brush.Style := bsSolid;
   brush.color := $606060;
   ellipse(x-18,y-18,x+19,y+19);
   pen.color := beltcolor;
   pen.Width := 3;
   if m > 0 then arc(x-19,y-19,x+20,y+20,x+20,y,x-20,y)
    else arc(x-19,y-19,x+20,y+20,x-20,y,x+20,y);
  end;
end;

procedure paintsmallWheel(x,y: smallInt; q: byte);
//on mapC
//q quadrant 1..4
var x1,y1,x2,y2 : smallInt;
begin
 with mapC.Canvas do
  begin
   brush.Style := bsSolid;
   pen.Width := 1;
   brush.Color := $000080;
   ellipse(x-8,y-8,x+9,y+9);
   case q of
    1 : begin
         x1 := x+10;
         y1 := y;
         x2 := x;
         y2 := y-10;
        end;
    2 : begin
         x1 := x;
         y1 := y-10;
         x2 := x-10;
         y2 := y;
        end;
    3 : begin
         x1 := x-10;
         y1 := y;
         x2 := x;
         y2 := y+10;
        end;
    4 : begin
         x1 := x;
         y1 := y+10;
         x2 := x+10;
         y2 := y;
        end;
    else x1:=0;y1:=0;x2:=0;y2:=0;
   end;//case
   pen.Width := 3;
   pen.color := beltcolor;
   arc(x-9,y-9,x+10,y+10,x1,y1,x2,y2);
  end;
end;

procedure paintB(x,y : word);
//on mapA
var i : byte;
    y1 : word;
begin
 y1 := y + 860;
 with mapA do with canvas do
  begin
   pen.width:= 1;
   for i := 0 to 19 do
    begin
     pen.color := $a0a0a0 - abs(4-i)*$040404;
     moveto(x+i,y);
     lineto(x+i,y1);
    end;
  end;
end;

procedure paintE;
//on mapA
var r : Trect;
    w : word;
    col : dword;
begin
 with mapA do with canvas do
  begin
   brush.color := $ffffff;
   brush.Style := bsSolid;
   r := rect(EXbias,EYbias,771,781);
   fillrect(r);
   pen.Color := $fff0f0;
   pen.Width := 1;
   w := 0;
   while w <= 640 do
    begin
     if w = 320 then col := $c00000
      else if (w mod 40) = 0 then col := $ffc0c0
            else col := $ffe0e0;
     pen.Color := col;
     moveto(EXbias,w+EYbias);
     lineto(770,w+EYbias);
     moveto(w+EXbias,EYbias);
     lineto(w+EXbias,780);
     inc(w,20);
    end;
   pen.Color := $000000;
   moveto(129,139);
   lineto(129,781);
   lineto(771,781);
   lineto(771,139);
   lineto(129,139);
  end;
end;

procedure paintchain(mp: Tbitmap;x1,y1,x2,y2 : word);
begin
 with mp do with canvas do
  begin
   pen.width := 3;
   pen.Color := beltcolor;
   moveto(x1,y1);
   lineto(x2,y2);
  end;
end;

procedure paintleftmotor(x,y: word);
//on mapA
var r : Trect;
    i : byte;
    dx : word;
begin
 with mapA do with canvas do
  begin
   pen.Width := 1;
   for i := 0 to 59 do
    begin
     pen.Color := $c0c0c0-abs(20-i)*$020202;
     dx := trunc(0.5*sqrt(900-sqr(i-30)));
     moveto(x+dx+45,y+i);
     lineto(x+dx+105,y+i);
    end;
   brush.Color := $404040;
   pen.Color := $606060;
   ellipse(x+30,y,x+60,y+60);
   arc(x+90,y,x+120,y+60,x+105,y+120,x+105,y);
   moveto(x+45,y);
   lineto(x+105,y);
   moveto(x+45,y+59);
   lineto(x+105,y+59);
   pen.Color := $000000;
   pen.Width := 4;
   ellipse(x+38,y+21,x+50,y+39);
   brush.Color := $808080;
   pen.Color := $808080;
   pen.Width := 1;
   ellipse(x+42,y+25,x+48,y+35);
   r := rect(x,Y+25,x+45,y+35);
   fillrect(r);
  end;
end;

procedure paintrightmotor(x,y: word);
//on mapA
var i : byte;
    dx : word;
    r : Trect;
begin
 with mapA do with canvas do
  begin
   pen.Width := 1;
   for i := 0 to 59 do
    begin
     pen.Color := $c0c0c0-abs(20-i)*$020202;
     dx := trunc(0.5*sqrt(900-sqr(i-30)));
     moveto(x+15-dx,y+i);
     lineto(x+75-dx,y+i);
    end;
   brush.Color := $404040;
   pen.Color := $606060;
   ellipse(x+60,y,x+90,y+60);
   arc(x,y,x+30,y+60,x+15,y,x+15,y+60);
   moveto(x+15,y);
   lineto(x+75,y);
   moveto(x+15,y+59);
   lineto(x+75,y+59);
   pen.color := $000000;
   pen.Width := 4;
   ellipse(x+68,y+21,x+82,y+39);
   pen.Width := 1;
   brush.Color := $808080;
   pen.Color := $808080;
   ellipse(x+72,y+25,x+78,y+35);
   r := rect(x+75,y+25,x+120,y+35);
   fillrect(r);
  end;
end;

procedure paintmapA;
var r : Trect;
begin
 with mapA do with canvas do
  begin
   brush.color := BGcolorA;
   brush.style := bsSolid;
   r := rect(0,0,width,height);
   fillrect(r);
   paintleftMotor(50,10);
   paintrightmotor(730,10);
   paintB(30,40);
   paintB(850,40);
   paintE;
   paintwheel(40,40,1);
   paintwheel(40,900,-1);
   paintwheel(860,40,1);
   paintwheel(860,900,-1);
   paintChain(mapA,21,40,21,900);
   paintchain(mapA,59,40,59,900);
   paintchain(mapA,841,40,841,900);
   paintChain(mapA,879,40,879,900);
  end;
end;

procedure paintmapC;
var r : Trect;
    i : byte;
begin
 with mapC do with canvas do
  begin
   brush.Style := bsSolid;
   brush.Color := $ffffff;
   r := rect(0,0,width,height);
   fillrect(r);
   brush.color := $00c0ff;
   pen.Width := 2;
   pen.Color := $0;
   roundrect(11,1,90,140,10,10);
   roundrect(811,1,890,140,10,10);
   paintsmallWheel(68,50,3);
   paintsmallwheel(68,119,2);
   paintsmallwheel(832,50,4);
   paintsmallwheel(832,119,1);
   pen.Width := 1;
   for i := 0 to 11 do
    begin
     pen.Color := $a0a0a0-abs(2-i)*$040404;
     moveto(90,30+i);
     lineto(810,30+i);
     moveto(90,80+i);
     lineto(810,80+i);
    end;
   paintchain(mapC,21,0,21,140);
   paintchain(mapC,59,0,59,50);
   paintchain(mapC,59,120,59,140);
   paintchain(mapC,879,0,879,140);
   paintchain(mapC,841,0,841,50);
   paintchain(mapC,841,120,841,140);
   paintchain(mapC,68,109,832,109);
   transparent := true;
   transparentcolor := $ffffff;
  end;
end;

procedure paintmapD;
var r : Trect;
begin
 with mapD do with canvas do
  begin
   brush.Color := $ffffff;
   brush.Style := bsSolid;
   r:= rect(0,0,width,height);
   fillrect(r);
   brush.color := $00c0ff;
   pen.Width := 2;
   pen.Color := $000000;
   roundrect(1,1,80,80,10,10);
   pen.Width := 1;
   pen.color := $000000;
   brush.Color := $ffffff;
   ellipse(32,32,48,48);
   brush.Color := $000000;
   pen.Width := 1;
   r := rect(0,35,10,45);
   fillrect(r);
   r := rect(70,35,80,45);
   fillrect(r);
   transparent := true;
   transparentcolor := $ffffff;
  end;
end;

procedure paintpenmovemap1;
begin
 with penmovemap1 do with Canvas do
  begin
   brush.Color := form1.Color;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   pen.Width := 1;
   pen.Color := $000000;
   brush.Color := $c0c0c0;
   ellipse(5,5,116,116);
   pen.width := 5;
   pen.Color := $808080;
   moveto(60,20);
   lineto(60,100);
   moveto(20,60);
   lineto(101,60);
   moveto(30,30);
   lineto(91,91);
   moveto(90,30);
   lineto(29,91);
  end;
end;

procedure paintpencontrolmap;
var d : word;
    i,j : byte;
begin
 with pencontrolmap do with canvas do
  begin
   brush.Color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   for i := 0 to width-1 do
    for j := 0 to height-1 do
     if sqrt(sqr(15-i)+sqr(15-j)) < 15 then
      begin
       d := round(sqrt(sqr(10-i)+sqr(10-j)));
       pixels[i,j] := $e0e0e0 - d*($0a0a0a);
      end;
   transparent := true;
   transparentcolor := $ffffff;
  end;
end;

procedure placeC;
//on mapX
//include top horizontal belt
var y : word;
begin
 y := CYbias+posY;
 with mapX.Canvas do
  begin
   Draw(0,y,mapC);
   pen.color := beltcolor;
   pen.Width := 3;
   moveto(68,y+60);
   lineto(430+posX,y+60);
   moveto(470+posX,y+60);
   lineto(832,y+60);
  end;
end;

procedure placeD;
//on mapX
var x,y : word;
begin
 x := DXbias + posX;
 y := DYbias + posY;
 mapX.Canvas.Draw(x,y,mapD);
end;

procedure makeCrect(var r : Trect);
begin
 with r do
  begin
   left := 0;
   right := 900;
   top := CYbias+posY;
   bottom := top+140;
  end;
end;

procedure XpartialToBox;
var r : Trect;
begin
 with form1.PaintBox1.Canvas do
  begin
   copyrect(leftColumnRect,mapX.Canvas,leftColumnrect);
   copyrect(rightcolumnRect,mapX.Canvas,rightColumnRect);
   makeCrect(r);
   r.Top := r.Top-1;
   r.Bottom := r.Bottom+1;
   copyrect(r,mapX.canvas,r);
  end;
end;

procedure placepenmovemap(x,y : word);
begin
 penmovemap2.Canvas.Draw(0,0,penmovemap1);
 penmovemap2.Canvas.Draw(x,y,pencontrolmap);
 form1.PaintBox1.Canvas.Draw(0,0,penmovemap2);
end;

procedure procAWheelmovement;
var a : single;
    x,y,sina,cosa : word;
    i : byte;
begin
 with mapX.canvas do
  begin
   pen.width := 2;
   pen.color := $00c0ff;
   for i := 1 to 4 do
    begin
     x := wheelcenter[i].x;
     y := wheelcenter[i].y;
     case i of
      1,3 : a := ((posX+posY+660) mod 30)*pi*0.0167;
      2,4 : a := ((posX-posY+660) mod 30)*pi*0.0167;
      else a := 0;
     end;
     sina := round(16*sin(a));
     cosa := round(16*cos(a));
     moveto(x+sina,y-cosa);
     lineto(x-sina,y+cosa);
     moveto(x-cosa,y-sina);
     lineto(x+cosa,y+sina);
    end;
   pen.color := $000000;
   pen.Width := 1;
   brush.Color := $000000;
   brush.Style := bsSolid;
   for i := 1 to 4 do
    begin
     x := wheelcenter[i].x;
     y := wheelcenter[i].Y;
     ellipse(x-5,y-5,x+5,y+5);  //black dot in wheel center
    end;
  end;
end;

procedure procCwheelmovement;
var a : single;
    x,y : word;
    i : byte;
    sina,cosa : smallInt;
begin
 with mapX.canvas do
  begin
   pen.width := 2;
   pen.color := $ff00ff;
   a := ((360-posX) mod 60)*pi*0.0333;
   sina := round(7*sin(a));
   cosa := round(7*cos(a));
   for i := 1 to 4 do
    begin
     x := wheelcenterC[i].x;
     y := wheelcenterC[i].y + CYbias + posY; 
     moveto(x,y);
     lineto(x+sina,y-cosa);
    end;
  end;
end;

procedure procBeltMovement;
var n : byte;
    x,y : word;
    d,pos : word;
    a : single;
label Lpaint;
begin
 n := 0;
 while n < markercount do
  begin
   inc(n);
   pos := beltmarkers[n];
//-------------stretch 1
   d := wheelcenterC[2].X-(450+posX);
   if pos < d then
    begin
     x := 450+posX+pos;
     y := 459+posY;
     goto Lpaint;
    end else pos := pos - d;
//------------stretch 2
   if pos < 16 then
    begin
     a := 0.0333*pi*pos;
     x := wheelcenterC[2].x+round(8*sin(a));
     y := wheelcenterC[2].y+CYbias+round(8*cos(a))+posY;
     goto Lpaint;
    end else pos := pos - 15;
//------------stretch 3
   d := CYbias+posY+wheelcenterC[2].y-wheelcenter[2].y;
   if pos < d then
    begin
     x := 840;
     y := CYbias+wheelcenterC[2].y+posY-pos;
     goto Lpaint;
    end else pos := pos - d;
//-----------stretch 4
   if pos < 60 then
    begin
     a := 0.01667*pi*pos;
     x := wheelcenter[2].X - round(19*cos(a));
     y := wheelcenter[2].Y - round(19*sin(a));
     goto Lpaint;
    end else pos := pos - 60;
//-----------------stretch 5
   d := wheelcenter[4].y - wheelcenter[2].y;
   if pos < d then
    begin
     x := wheelcenter[2].x + 18;
     y := wheelcenter[2].y + pos;
     goto Lpaint;
    end else pos := pos - d;
//---------------stretch 6
   if pos < 60 then
    begin
     a := 0.01667*pi*pos;
     x := wheelcenter[4].x + round(19*cos(a));
     y := wheelcenter[4].y + round(19*sin(a));
     goto Lpaint;
    end else pos := pos - 60;
//---------------stretch 7
   d := wheelcenter[4].Y-(wheelcenterC[4].y+CYbias+posY);
   if pos < d then
    begin
     x := 840;
     y := wheelcenter[4].Y - pos;
     goto Lpaint;
    end else pos := pos - d;
//--------------stretch 8
   if pos < 16 then
    begin
     a := 0.0333*pi*pos;
     x := wheelcenterC[4].x + round(8*cos(a));
     y := wheelcenterC[4].Y + CYbias+posY- round(10*sin(a));
     goto Lpaint;
    end else pos := pos - 15;
//-------------stretch 9
   d := wheelcenterC[4].x - wheelcenterC[3].X;
   if pos < d then
    begin
     x := wheelcenterC[4].X - pos;
     y := wheelcenterC[3].Y+CYbias+posY-11;
     goto Lpaint;
    end else pos := pos - d;
//-------------stretch 10
   if pos < 16 then
    begin
     a := 0.0333*pi*pos;
     x := wheelcenterC[3].X - round(10*sin(a));
     y := wheelcenterC[3].Y + CYbias + posY -round(10*cos(a));
     goto Lpaint;
    end else pos := pos - 15;
//------------stretch 11
   d := wheelcenter[3].Y - (wheelcenterC[3].y + CYbias + posY);
   if pos < d then
    begin
     x := wheelcenter[3].X + 18;
     y := wheelcenterC[3].Y + CYbias + posY + pos;
     goto Lpaint;
    end else pos := pos - d;
//-----------stretch 12
   if pos < 60 then
    begin
     a := 0.01667*pi*pos;
     x := wheelcenter[3].x + round(19*cos(a));
     y := wheelcenter[3].y + round(19*sin(a));
     goto Lpaint;
    end else pos := pos - 60;
//----------stretch 13
   d := wheelcenter[3].Y-wheelcenter[1].Y;
   if pos < d then
    begin
     x := wheelcenter[3].x-20;
     y := wheelcenter[3].Y - pos;
     goto Lpaint;
     end else pos := pos - d;
//----------stretch 14
  if pos < 60 then
   begin
    a := 0.01667*pi*pos;
    x := wheelcenter[1].x - round(20*cos(a));
    y := wheelcenter[1].y - round(20*sin(a));
    goto Lpaint;
    end else pos := pos - 60;
//---------stretch 15
   d := CYbias + posY + wheelcenterC[1].Y - wheelcenter[1].Y;
   if pos< d then
    begin
     x := wheelcenter[1].X+18;
     y := wheelcenter[1].Y + pos;
     goto Lpaint;
    end else pos := pos - d;
//----------stretch 16
   if pos < 16 then
    begin
     a := 0.0333*pi*pos;
     x := wheelcenterC[1].X - round(9*cos(a));
     y := wheelcenterC[1].Y + CYbias + posY +round(9*sin(a));
     goto Lpaint;
    end else pos := pos - 15;
//---------stretch 17
   x := wheelcenterC[1].X + pos;
   y := wheelcenterC[1].Y+9+Cybias+posY;

Lpaint :

   mapX.Canvas.Draw(x,y,purpledot);

  end;//while
end;

procedure paintdot;
const pencolor = $ff0000;
//in area E on mapA at (posx,posy)
var x,y : word;
begin
 with mapA.Canvas do
  begin
   x := posX+450;
   y := posY+460;
   pixels[x,y] := pencolor;
   pixels[x+1,y] := pencolor;
   pixels[x,y+1] := pencolor;
   pixels[x+1,y+1] := pencolor;
  end;
end;

procedure setpen(down : boolean);
begin
 pendownFlag := down;
 if down then paintdot;
end;

procedure moveControl(dir : byte);
//move in direction dir 0..7
const pencolor = $ff0000;
var OK : boolean;
    r : Trect;
begin
 OK := false;
 makeCrect(r);
 case dir of
  0 : if posX < 320 then
       begin
        inc(posX);
        OK := true;
       end;
  1 : if (posX < 320) and (posy > -320) then
       begin
        inc(posX);
        dec(posY);
        OK := true;
       end;
  2 : if (posy > -320) then
       begin
        dec(posY);
        OK := true;
       end;
  3 : if (posX > -320) and (posY > -320) then
       begin
        dec(posX);
        dec(posY);
        OK := true;
       end;
  4 : if posX > -320 then
       begin
        dec(posX);
        OK := true;
       end;
  5 : if (posX > -320) and (posY < 320) then
       begin
        dec(posX);
        inc(posY);
        OK := true;
       end;
  6 : if (posY < 320) then
       begin
        inc(posY);
        OK := true;
       end;
  7 : if (posX < 320) and (posy < 320) then
       begin
        inc(posX);
        inc(posY);
        OK := true;
       end;
 end;//case
 if OK then
  begin
   if pendownflag then paintdot;
   mapX.Canvas.copyrect(r,mapA.canvas,r); //restore C,D area
   mapX.Canvas.CopyRect(leftColumnRect,mapA.Canvas,leftColumnRect);
   mapX.Canvas.copyrect(rightColumnRect,mapA.Canvas,rightColumnRect);
   placeC;
   placeD;
   procAWheelmovement;
   procCwheelmovement;
   procBeltMovement;
   XpartialToBox;
  end else moveFlag := false;
end;

procedure procmove(dir : byte);
var t1,t2 : int64;
    timeout : word;
begin
 timeout := Vtimeout[speedcode];
 if (dir and 1) = 1 then timeout := timeout shl 1;//single motor operation
 moveFlag := true;
 t1 := getCPUticks;
 movecontrol(dir);
 showposition;
 t2 := getCPUticks;
 reporttime(t2-t1);
 showprocUsage(procTime(t2-t1)/timeout);
 if form1.stepBtn.Checked then moveFlag := false;
  repeat
   t2 := getCPUticks;
   application.ProcessMessages;
  until proctime(t2-t1) > timeout;
end;

procedure createELbox(var pb : TDav7ELbox; x,y,w,h : word;tg : byte);
begin
 pb := TDav7ELbox.create(form1);
 with pb do
  begin
   parent := form1;
   left := x;
   top := y;
   width := w;
   height := h;
   tag := tg;
  end;
end;

procedure createMap(var map : Tbitmap; w,h : word);
begin
 map := TBitmap.Create;
 with map do
  begin
   width := w;
   height := h;
   pixelformat := pf32bit;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 decimalseparator := '.';
 createmap(mapA,900,940);
 createmap(mapC,900,140);
 createmap(mapD,80,80);
 createmap(mapX,900,940);
 createmap(penmovemap1,120,120);
 createmap(penmovemap2,120,120);
 createmap(pencontrolmap,30,30);
 paintmapA;
 paintmapC;
 paintmapD;
 paintpenmovemap1;
 paintpencontrolmap;
 penmovemap2.Canvas.Draw(0,0,penmovemap1);
 createELbox(MLbox,920,400,25,60,1);
 MLbox.OnPaint := MLboxpaint;
 MLbox.onEnter := MLboxEnter;
 MLbox.onLeave := MLboxLeave;
 MLbox.OnMouseDown := MLboxMouseDown;
 MLbox.OnMouseUp := MLboxMouseUp;
 createELbox(MRbox,1035,400,25,60,2);
 MRbox.OnPaint := MLboxpaint;
 MRbox.onEnter := MLboxEnter;
 MRbox.onLeave := MLboxLeave;
 MRbox.OnMouseDown := MLboxMouseDown;
 MRbox.OnMouseUp := MLboxMouseUp;
 createELbox(MLRbox1,955,400,30,60,3);
 MLRbox1.onPaint := MLboxpaint;
 MLRbox1.onEnter := MLboxEnter;
 MLRbox1.onLeave := MLboxLeave;
 MLRbox1.OnMouseDown := MLboxMouseDown;
 MLRbox1.OnMouseUp := MLboxMouseUp;
 createELbox(MLRbox2,995,400,30,60,4);
 MLRbox2.OnPaint := MLboxpaint;
 MLRbox2.onEnter := MLboxEnter;
 MLRbox2.onLeave := MLboxLeave;
 MLRbox2.OnMouseDown := MLboxMouseDown;
 MLRbox2.OnMouseUp := MLboxMouseUp;
 purpledot := Tbitmap.Create;
 with purpledot do with canvas do
  begin
   width := 3;
   height := 3;
   brush.Color := $ff00ff;
   fillrect(rect(0,0,3,3));
  end;
 AtoX;
 placeC;
 placeD;
 procAwheelmovement;
 procCwheelmovement;
 procBeltMovement;
 Xtobox;
 showposition;
 placepenmovemap(45,45);
 createscanmap;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 mapA.free;
 mapC.Free;
 mapD.Free;
 mapX.Free;
 MLbox.Free;
 MRbox.Free;
 MLRbox1.Free;
 MLRbox2.Free;
 penmovemap1.Free;
 penmovemap2.Free;
 pencontrolmap.free;
 purpledot.Free;
 destroyscanmap;
end;

procedure Edge(ct : Tcontrol; w : byte; col1,col2 : dword);
//paint edge around control ct
var x1,y1,x2,y2 : word;
    i : byte;
    par : TCustomform;
begin
 par := getParentform(ct);
 with par do
  begin
   x1 := ct.Left-w;
   y1 := ct.Top-w;
   x2 := ct.Left + ct.Width + w - 1;
   y2 := ct.Top + ct.Height + w - 1;
  end;
 with par.Canvas do
  begin
   pen.Width := 1;
   for i := 0 to w-1 do
    begin
     pen.Color := col1;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.Color := col2;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 Edge(paintbox1,2,$808080,$808080);
 Edge(MLbox,2,$707070,$707070);
 Edge(MRbox,2,$707070,$707070);
 Edge(MLRbox1,2,$707070,$707070);
 Edge(MLRbox2,2,$707070,$707070);
 Edge(procbox,2,$808080,$808080);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 XtoBox;
end;

procedure TForm1.slowBtnMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 speedcode := Tspeedbutton(sender).Tag;
end;

procedure TForm1.procboxPaint(Sender: TObject);
var r : Trect;
begin
 with procbox do with canvas do
  begin
   brush.color := $ffffff;
   brush.Style := bsSolid;
   r := rect(0,0,width,height);
   fillrect(r);
  end;
end;

procedure TForm1.penmoveBoxPaint(Sender: TObject);
begin
 penmovebox.Canvas.Draw(0,0,penmovemap2);
end;

procedure procXpainting;
//called by mouse move
begin
 moveflag := true;
 while moveflag do procmove(xdircode);
end;

procedure displaypaintball(cell : byte);
const bcoord : array[0..8] of Tpoint =
              ((x:35;y:35),(x:60;y:25),(x:85;y:35),
               (x:25;y:60),(x:60;y:60),(x:95;y:60),
               (x:35;y:85),(x:60;y:95),(x:85;y:85));
begin
 penmovemap2.Canvas.Draw(0,0,penmovemap1);
 penmovemap2.Canvas.Draw(bcoord[cell].X-15,bcoord[cell].Y-15,pencontrolmap);
 form1.penmovebox.Canvas.Draw(0,0,penmovemap2);
end;

procedure TForm1.penmoveBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var col,row : word;
begin
 col := x div 40;
 row := y div 40;
 if (col=1) and (row=1) then
  begin
   movebusy := true;
   if button = mbLeft then setpen(true);
  end;
end;

procedure TForm1.penmoveBoxMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
const cell2dir : array[0..8] of byte = (3,2,1,4,$ff,0,5,6,7);
var col,row,cell : byte;
begin
 if (x > 120) or (x < 0) or (y > 120) or (y < 0) then
  begin
   movebusy := false;
   moveflag := false;
  end;
 if movebusy then
  begin
   if x < 45 then col := 0
    else if x < 75 then col := 1 else col := 2;
   if y < 45 then row := 0
    else if y < 75 then row := 1 else row := 2;
   cell := col + 3*row;
   case cell of
    1 : if y > 30 then cell := 4;
    3 : if x > 30 then cell := 4;
    5 : if x < 90 then cell := 4;
    7 : if y < 90 then cell := 4;
   end;
   displaypaintball(cell);
   if cell = 4 then moveflag := false
    else
     begin
      xdircode := cell2dir[cell];
      if moveflag = false then procXpainting; //if not moving already
     end;
  end;//if movebusy  
end;

procedure TForm1.penmoveBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 movebusy := false;
 moveflag := false;
 setpen(false);
 displaypaintball(4);
end;

procedure TForm1.eraseBtnClick(Sender: TObject);
begin
 paintE;
 AtoX;
 placeC;
 placeD;
 procAwheelmovement;
 procCwheelmovement;
 procBeltMovement;
 Xtobox;
end;

procedure TForm1.demoBtn1Click(Sender: TObject);
//button tag = demo nr.
begin
 startdemo(TBitBtn(sender).tag);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 GoDemoFlag := false;//stop demo
end;

procedure TForm1.resetBtnClick(Sender: TObject);
//position pen at (0,0)
const mc : array[1..10] of byte = (4,0,0,2,3,1,0,6,5,7);
var GO : boolean;
     m : byte;
begin
 pendownflag := false;
 GO := true;
 while GO do
  begin
   if posX > 0 then m := 1
    else if posX < 0 then m := 2
          else m := 0;
   if posY > 0 then m := m or 4
    else if posY < 0 then m := m or 8;
   GO := m <> 0;
   if GO then procmove(mc[m]);
  end;
 showposition;
 showprocUsage(0);
end;

//-- motor buttons ---

procedure TForm1.MLBoxMouseDown(sender: TObject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);
const movecode: array[1..8] of byte = (3,1,2,4,7,5,6,0);
var bx : TDav7ELbox;
    moveIx : byte;
begin
 bx := TDav7ELbox(sender);
 Edge(bx,2,$000000,$ffffff);
 moveFlag := true;
 moveIx := bx.Tag;
 if (y > 30) xor (button = mbRight) then inc(moveIx,4);
 while moveFlag do procmove(moveCode[moveIx]);//moveflag cleared by mouseUP
end;

procedure TForm1.MLboxMouseUp(sender: TObject; Button: TMouseButton;
                              Shift: TShiftState; X, Y: Integer);
var bx : TDav7ELbox;
begin
 bx := TDav7ELbox(sender);
 Edge(bx,2,$ffffff,$000000);
 moveFlag := false;
end;

procedure TForm1.MLboxEnter(sender: TObject);
begin
 Edge(TControl(sender),2,$ffffff,$000000);
end;

procedure TForm1.MLboxLeave(sender: TObject);
begin
 Edge(TControl(sender),2,$707070,$707070);
end;

procedure Tform1.MLboxpaint(sender : TObject);
var bx : TDav7ELbox;

 procedure MCarrow(x,y1,y2 : byte);
 var d : shortInt;
 begin
  if y1<y2 then d := -1 else d := 1;
  with bx.Canvas do
   begin
    pen.Width := 3;
    moveto(x,y1);
    lineto(x,y2);
    pen.Width := 2;
    moveto(x+4,y2+4*d);
    lineto(x,y2);
    lineto(x-4,y2+4*d);
   end;
 end;

begin
 bx := TDav7ELbox(sender);
 with bx do with canvas do
  begin
   brush.Color := $c0c0c0;
   fillrect(rect(0,0,width,height));
   pen.Color := $000000;
   case tag of
    1,2 : begin
           MCarrow(12,25,5);
           MCarrow(12,35,55);
          end;
      3 : begin
           MCarrow(7,25,5);
           MCarrow(22,25,5);
           MCarrow(7,35,55);
           MCarrow(22,35,55);
          end;
      4 : begin
           MCarrow(7,25,5);
           MCarrow(22,5,25);
           MCarrow(7,35,55);
           MCarrow(22,55,35);
          end;
   end;//case
  end;
end;

end.
